<template>
  <q-page class="q-px-md q-mt-md">
    <q-btn
      @click="handleClickBack()"
      class="text-center"
      color="red"
      icon="arrow_back_ios"
      >กลับ</q-btn
    >

    <div class="row q-gutter-x-sm">
      <div class="col-md-12">
        <q-card class="q-px-sm ">
          <q-card-section class="q-py-none ">
            <h6 class="q-my-sm q-pt-md">รายงานผลประกอบการ</h6>
          </q-card-section>
          <q-card-section>
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 40px; min-width: 80px;"
              >
                ประเภทเกม
              </div>
              <div class="col">
                <q-checkbox
                  v-model="game_type"
                  :key="item.code"
                  v-for="item in groupList"
                  :val="item.code"
                  :label="item.code"
                />
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 50px; min-width: 80px;"
              >
                ผู้ให้บริการ
              </div>
              <div class="col">
                <q-checkbox
                  v-model="provider_code"
                  :key="item.code"
                  v-for="item in providerList"
                  :val="item.code"
                  :label="item.code"
                />
                <!-- <q-select
                  outlined
                  dense
                  v-model="provider_code"
                  multiple
                  :options="providerList"
                  option-value="code"
                  option-label="name"
                  emit-value
                  style="min-width: 250px; "
                >
                  <template v-if="provider_code.length > 0" v-slot:append>
                    <q-icon
                      name="cancel"
                      @click.stop="provider_code = []"
                      class="cursor-pointer"
                    />
                  </template>
                </q-select> -->
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <StartDateEndDateFilterComponent :filter="dateFilter" />
          </q-card-section>
          <q-card-section class="q-py-sm">
            <q-input
              bg-color="grey-13"
              @keydown.enter="onSearch"
              v-model.trim="filter.username"
              placeholder="ค้นหา อย่างน้อย 3 ตัวอักษร"
              outlined
              dense
              style="width:400px"
            >
              <template v-slot:prepend>
                <q-icon name="search" class="pointer" />
              </template>
              <template v-slot:append>
                <q-icon
                  v-if="filter.username !== ''"
                  name="close"
                  @click="
                    e => {
                      filter.username = undefined;
                      onRequest({
                        pagination: pagination,
                        filter: filter
                      });
                    }
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:after>
                <q-btn color="green" @click.prevent="onSearch" icon="search"
                  >ค้นหา</q-btn
                >
              </template>
            </q-input>
          </q-card-section>

          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :pagination.sync="pagination"
            :loading="loading"
            :data="data.docs"
            separator="cell"
            row-key="id"
            @request="onRequest"
          >
            <template slot="header" slot-scope="props" :props="props">
              <q-tr>
                <q-th rowspan="2" class="bg-blue-9 text-white">
                  ยูสเซอร์เนม
                </q-th>

                <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
                <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
                <q-th
                  v-if="role <= 5"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 4 >= role ? "ซีเนียร์" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 4"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 3 >= role ? "ผู้ถือหุ่น" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 3"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 2 >= role ? "คอมปะนี" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 2"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 1 >= role ? "Smart Bet" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 1"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 0 >= role ? "Provider" : "คอมปะนี" }}
                </q-th>
              </q-tr>
              <q-tr>
                <q-th
                  class="bg-light-blue-5 text-white"
                  v-for="index in role < 2 ? 7 : 6 - role + 2"
                  :key="index"
                  >W/L
                </q-th>
              </q-tr>
            </template>
            <template slot="body" slot-scope="props" :props="props">
              <tr>
                <td class="flex justify-center text-center">
                  <!-- <q-btn
                    @click="handleClickUserName(props.row)"
                    flat
                    color="primary"
                  >
                    {{ props.row.username }}
                  </q-btn> -->

                  <div
                    class="cursor-pointer"
                    @click="handleClickUserName(props.row)"
                    style="justify-content: center;align-items: center;display: flex;"
                  >
                    {{ props.row.username }}
                  </div>
                  <q-btn
                    @click="handleClickCopy(props.row.username)"
                    flat
                    round
                    icon="content_copy"
                  />
                </td>
                <td
                  class="text-center"
                  :class="bgFunc(getWinLoseMember(props.row, 6))"
                >
                  <!-- level 6 สมาชิก -->

                  {{ getWinLoseMember(props.row, 6) }}
                </td>
                <td
                  class="text-center"
                  :class="bgFunc(getWinLoseMember(props.row, 5))"
                >
                  <!-- level 5 สมาชิก -->

                  {{ getWinLoseMember(props.row, 5) }}
                </td>
                <td
                  :class="bgFunc(getWinLoseMember(props.row, 4))"
                  class="text-center"
                  v-if="role <= 5"
                >
                  <!-- level 4 สมาชิก -->

                  {{ getWinLoseMember(props.row, 4) }}
                </td>
                <td
                  :class="bgFunc(getWinLoseMember(props.row, 3))"
                  class="text-center"
                  v-if="role <= 4"
                >
                  <!-- level 3 สมาชิก -->

                  {{ getWinLoseMember(props.row, 3) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 3"
                  :class="bgFunc(getWinLoseMember(props.row, 2))"
                >
                  <!-- level 2 สมาชิก -->

                  {{ getWinLoseMember(props.row, 2) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 2"
                  :class="bgFunc(getWinLoseMember(props.row, 1))"
                >
                  {{ getWinLoseMember(props.row, 1) }}
                </td>
                <!-- <td
                  class="text-center"
                  v-if="role <= 1"
                  :class="bgFunc(getWinLoseMember(props.row, 0))"
                >

                  {{ getWinLoseMember(props.row, 0) }}
                </td> -->
                <td class="text-center" v-if="role <= 1">
                  0.00
                </td>
              </tr>
            </template>
            <template v-slot:loading>
              <q-inner-loading showing color="primary" />
            </template>
          </q-table>
        </q-card>
      </div>
    </div>
    <TransactionModal v-bind.sync="transactionModal" />
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions, mapMutations } from "vuex";
import { SessionStorage, LocalStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";
import TransactionModal from "src/components/transactionModal.vue";
import { copyToClipboard } from "quasar";

import _ from "lodash";

const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");
export default {
  name: "Index",
  components: {
    StartDateEndDateFilterComponent,
    TransactionModal
  },
  props: {
    isClick: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      data: [],
      downlineData: null,
      targetRole: null,
      loading: false,
      dateFilter: {
        // startDate: new Date().setDate(1),
        // startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        // endDate: new Date(
        //   new Date().getFullYear(),
        //   new Date().getMonth() + 1
        // ).setDate(0),
        // endTime: new Date(new Date().setHours(23, 59, 59, 999))
        startDate:
          new Date().getDate() !== 1
            ? new Date().setDate(1)
            : new Date(
                new Date().getFullYear(),
                new Date().getMonth() - 1
              ).setDate(1),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date().setDate(new Date().getDate() - 1),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      filter: {
        username: undefined,
        parent_id: undefined,
        level: undefined
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 25,
        rowsNumber: 0
      },
      groupList: [],
      providerList: [],
      transactionModal: {
        modal: false,
        user: undefined,
        id: undefined
      }
    };
  },

  async created() {
    document.title = "Report";
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
      this.game_type = this.groupList
        .filter(
          (item, index) =>
            this.groupList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    } else {
      try {
        const {
          data: { results }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
      this.provider_code = this.providerList
        .filter(
          (item, index) =>
            this.providerList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
          this.provider_code = this.providerList
            .filter(
              (item, index) =>
                this.providerList.findIndex(r => r.code == item.code) == index
            )
            .map(x => x.code);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (this.settingData) {
      this.settingData.dateTime
        ? (this.dateFilter = this.settingData.dateTime)
        : null;
      this.settingData.game_type
        ? (this.game_type = this.settingData.game_type)
        : null;
      this.settingData.provider_code
        ? (this.provider_code = this.settingData.provider_code)
        : null;
    }
    if (
      this.$route.path !== "/v2/report/member" &&
      !this.$route.query.company
    ) {
      await this.onSearch();
    }
  },

  computed: {
    ...mapState("auth", ["role"]),
    ...mapGetters("report/v2", {
      settingData: "getDateTime"
    }),
    numberFormat() {
      return (number, digit = 2, comma = true) =>
        new Intl.NumberFormat("en-US", {
          minimumFractionDigits: digit,
          maximumFractionDigits: digit,
          useGrouping: comma
        }).format(number);
    },
    convertToFloat() {
      return number => parseFloat(this.numberFormat(number, 2, false));
    },
    bgFunc() {
      return inValue => {
        const value = this.convertToFloat(inValue.replace(/,/g, ""));

        if (value > 0) {
          return "text-green-8 text-bold";
        }
        if (value == 0) {
          return "";
        }
        return "text-red-10 text-bold";
      };
    },
    getWinLoseMember() {
      return (item, level) => {
        let report = _.cloneDeep(item.report);
        let wl = 0;
        if (report === 0) this.numberWithCommas(wl.toFixed(2));

        if ((this.role == 0 || this.role == 1) && level < 2) {
          let b = report.filter(x => x.level !== 6);
          let a = report.find(x => x.level === 6);
          let sum = 0;
          b.map(x => {
            sum += x.winLoss;
          });

          if ((b, a)) {
            a, b;
            wl = a.winLoss - sum;
          }
        } else if (level >= this.role) {
          const targetReport = report.find(x => x.level === level);
          if (targetReport) {
            wl = targetReport.winLoss;
            if (level == 6) {
              wl = wl * -1;
            }
          }
        } else {
          report = report.filter(x => x.level > level);

          // wl = report.reverse().reduce((a, b) => a.winLoss - b.winLoss);

          let b = report.filter(x => x.level !== 6);
          let a = report.find(x => x.level === 6);
          let sum = 0;
          b.map(x => {
            sum += x.winLoss;
          });

          if ((b, a)) {
            a, b;
            wl = a.winLoss - sum;
          }
        }

        // if (report?.length) {
        //   const targetReport = report.find(x => x.level === level);

        //   if (targetReport?.winLoss) {
        //     wl = targetReport.winLoss;
        //     if (targetReport.level == 6) {
        //       wl = wl * -1;
        //     }
        //   }
        // }

        return this.numberWithCommas(wl.toFixed(2));
      };
    }
  },

  methods: {
    ...mapActions("report/v2", [
      "getAllReport",
      "getOrganizationById",
      "getOrganization"
    ]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    ...mapMutations("report/v2", ["setDateTime", "setGameType", "setProvider"]),

    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
    },
    getFilterParameter({ filter = this.filter, pagination = this.pagination }) {
      if (this.$route.meta.level) {
        filter.level = this.$route.meta.level;
      }
      if (this.$route.params.id) {
        filter.parent_id = this.$route.params.id;
      } else {
        delete filter.parent_id;
      }
      let start = undefined;
      let end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }

      return {
        // ...filter,
        // ...pagination,
        search: filter.username,
        page: pagination.page,
        limit: pagination.rowsPerPage,
        typeCode: this.game_type.join(",")
          ? this.game_type.join(",")
          : undefined,
        providerCode: this.provider_code.join(",")
          ? this.provider_code.join(",")
          : undefined,
        start: new Date(start).toISOString(),
        end: new Date(end).toISOString()
      };
    },
    async onRequest(props) {
      try {
        // this.$q.loading.show();
        this.loading = true;

        const parameters = this.getFilterParameter(props);

        let rs = null;

        if (this.$route.path == "/v2/report/member") {
          const { data } = await this.getOrganization({
            ...parameters
          });

          rs = data.results;
        } else {
          const { data } = await this.getOrganizationById({
            ...parameters,
            id: this.$route.params.id
          });

          if (
            data.results.docs?.length !== 0 &&
            data.results.docs[0].level == 6
          ) {
            data.results.docs = data.results.docs.filter(x => {
              return x.report?.length;
            });
          }

          rs = data.results;
        }

        //  this.$route.path !== "/v2/report/member"

        // this.targetRole = this.data.docs[0].level;
        this.pagination.page = rs.page;
        this.pagination.rowsPerPage = rs.limit;
        this.pagination.rowsNumber = rs.totalDocs;
        this.data = rs;

        this.loading = false;
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
      this.$q.loading.hide();
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },

    getWinLose(level) {
      let report = [...this.data.report];
      let wl = 0;
      if (report.length === 0) return wl;

      if (level >= this.role) {
        const targetReport = report.find(x => x.level === level);
        if (targetReport) {
          wl = targetReport.winLoss;
          if (level == 6) {
            wl = wl * -1;
          }
        }
      } else {
        report = report.filter(x => x.level > level);

        wl = report.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      }

      return this.numberWithCommas(wl.toFixed(2));
    },
    numberWithCommas(x) {
      var parts = x.toString().split(".");
      parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      return parts.join(".");
    },

    handleClickUserName(userData) {
      this.setDataToSession();
      this.setDateTime(this.dateFilter);
      this.setGameType(this.game_type);
      this.setProvider(this.provider_code);
      if (userData.level < 6) {
        // this.$router.replace(`v2/report/${userData.accountId}`);

        // this.$router.replace({
        //   path: "v2/report",
        //   params: { id: userData.accountId }

        // });

        this.$router.replace({ path: `/v2/report/${userData.accountId}` });
      } else {
        //    transactionModal: {
        //   modal: false,
        //   username: undefined,
        //   id: undefined
        // }'

        this.$router.push({
          name: "report-member-with-member",
          params: {
            id: userData.accountId,
            username: userData.username
          }
        });

        // this.transactionModal.modal = true;
        // this.transactionModal.user = userData;
        // this.transactionModal.id = userData.accountId;
      }
    },
    handleClickBack() {
      // this.$router.back();
      // console.log(this.$router);
      // this.$router.go(-1);
      // console.log(this.$route.fullPath);
      // SessionStorage.set("from_path", this.$route.fullPath);
      if (SessionStorage.getItem(`from_path`)) {
        const from_path = SessionStorage.getItem(`from_path`);

        const path = from_path.pop();
        SessionStorage.set("from_path", from_path);

        if (path) this.$router.replace({ path: path });
        else this.$router.push("/v2/report");
      } else {
        this.$router.push("/v2/report");
      }
    },

    async setDataToSession() {
      // if (SessionStorage.getItem(`report_data`)) {
      //   let obj = JSON.parse(SessionStorage.getItem("report_data") || "{}");

      //   obj[this.$route.fullPath] = this.data;
      //   await SessionStorage.set("report_data", JSON.stringify(obj));
      // }

      if (SessionStorage.getItem(`from_path`)) {
        const from_path = SessionStorage.getItem(`from_path`);
        // this.$router.replace({ path: from_path });

        from_path.push(this.$route.fullPath);

        await SessionStorage.set("from_path", from_path);
      }
    },
    handleClickCopy(text) {
      copyToClipboard(text)
        .then(() => {
          // success!

          this.$q.notify({
            message: "text has been copy"
          });
        })
        .catch(() => {
          // fail
        });
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
